﻿Public Class Form4
    Public fle As New dofile
    Public _flpas As New List(Of String) 'ファイルのフルパスのリスト

    Private Sub f() Handles MyBase.Shown
        Me.Activate()
        Me.KeyPreview = True
        DateTimePicker1.Select()
    End Sub
    'コントロールの遷移
    Private Sub Form4_KeyPress(sender As System.Object, e As System.Windows.Forms.KeyPressEventArgs) Handles MyBase.KeyPress
        If e.KeyChar = Chr(Keys.Enter) Then
            Me.SelectNextControl(Me.ActiveControl, True, True, True, True)
            e.Handled = True
        End If
    End Sub
    '日付情報からListView1に表示
    Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
        fle.clrlist()   '
        ListView1.Items.Clear()
        Dim dt1 As String
        Dim dt2 As String
        dt1 = DateTimePicker1.Text
        dt2 = DateTimePicker2.Text
        Dim dat1 As DateTime = DateTime.Parse(dt1)
        Dim dat2 As DateTime = DateTime.Parse(dt2)
        If dat1 > dat2 Then
            MsgBox("日付を正しく入力してください。")
            Return
        End If

        fle.datfle(dat1, dat2)   'Class dofileに値を渡す

        'ListViewに表示メソッド
        lstview()
        
    End Sub
    'Process.Start
    Private Sub ListView1_DoubleClick(sender As System.Object, e As System.EventArgs) Handles ListView1.DoubleClick
        Dim selint As Integer
        selint = ListView1.SelectedIndices(0)
        Process.Start(fle._dtflnm(selint))
    End Sub
    'Form1に戻る
    Private Sub Button2_Click(sender As System.Object, e As System.EventArgs) Handles Button2.Click
        Dim f As New Form1
        f.Show()
        Me.Close()
    End Sub
    '削除
    Private Sub Button3_Click(sender As System.Object, e As System.EventArgs) Handles Button3.Click
        If _flpas.Count = 0 Then
            MsgBox("削除するファイルが" & vbNewLine & "選択されていません。")
        End If

        fle.fledelt(_flpas)       '削除するファイルのフルパスのリストとファイル名をClass dofileに渡す
        ListBox1.Items.Clear()

        'ListViewに表示メソッド
        lstview()
    End Sub
    '削除する項目の選択
    Private Sub ListView1_Click(sender As System.Object, e As System.EventArgs) Handles ListView1.Click
        Dim seli As Integer
        Dim flpas As String
        seli = ListView1.SelectedIndices(0)

        '削除するファイルのフルパス
        flpas = fle._dtflnm(seli)

        '同一の項目が選択された場合は何もしない
        If _flpas.Contains(flpas) Then
            Return
        End If

        _flpas.Add(flpas)   'ファイルのフルパスをAddする

        '削除するファイル名をListBox1に表示
        ListBox1.Items.Add(fle.dtnme(seli))

    End Sub
    '削除の取り消し
    Private Sub Button4_Click(sender As System.Object, e As System.EventArgs) Handles Button4.Click
        ListBox1.Items.Clear()
        _flpas.Clear()

        '削除する項目をリストから省く

    End Sub
    'ListView1表示メソッド
    Private Sub lstview()
        ListView1.Items.Clear()

        Dim cnt As Integer
        cnt = fle.dtnme.Count

        For k As Integer = 0 To cnt - 1
            ListView1.Items.Add(fle.dtnme(k))
            ListView1.Items(k).SubItems.Add(fle.dttm(k))
        Next
    End Sub
End Class