﻿Imports Microsoft.Office.Interop

Public Class doexcel
    Shared _dirpas As String                 '原紙パス
    Shared _sosname As String                '原紙名
    Public _flenme As String                 '原紙フィル名 
    Public _cellst As New List(Of String)    '各セルのリスト
    Public _txtlst As New List(Of String)    'Class Form2から受け取ったTextBoxの値のリスト   
    Public fledo As New dofile
    'Excelを開く
    Public Sub shopn(ByVal flenme As String)
        '
        _cellst.Clear()

        _flenme = flenme    '原紙フィル名 

        Try
            Dim xlApp As New Excel.Application
            Dim xlBook As Excel.Workbook
            Dim xlSheet As Excel.Worksheet
            Dim rng As Object 'Range オブジェクト

            'Excelブックを起動  _dirpas & "\" & flenme & ".xls"
            xlBook = xlApp.Workbooks.Open(_dirpas & "\" & flenme & ".xls")

            'Excelを表示
            xlApp.Visible = False

            'シートを指定
            xlSheet = DirectCast(xlBook.Worksheets(1), Excel.Worksheet)
            xlSheet.Activate()

            rng = DirectCast(xlSheet.Cells(4, "k"), Excel.Range)   '得意先名								
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(6, "k"), Excel.Range)   '図　番
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(8, "k"), Excel.Range)    '品　名
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(4, "ck"), Excel.Range)   '得意先注番
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(6, "ck"), Excel.Range)   '発注番号
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(8, "CC"), Excel.Range)   '
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(4, "db"), Excel.Range)   '受注数
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(6, "db"), Excel.Range)   '材料数
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(8, "db"), Excel.Range)   '材　質
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(4, "dy"), Excel.Range)   '加工予定数
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(6, "dy"), Excel.Range)   '完成在庫数
            _cellst.Add(rng.text.ToString())

            rng = DirectCast(xlSheet.Cells(8, "dy"), Excel.Range)   '材料サイズ
            _cellst.Add(rng.text.ToString())

            xlBook.Close()
            xlApp.Quit()
    
        '終了処理
        xlSheet = Nothing
        xlBook = Nothing
        xlApp = Nothing
            Dim ps() As Process = Process.GetProcessesByName("Excel")
            For Each p As Process In ps
                p.Kill()
            Next
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
    End Sub
    'Class Form2からTextBoxの値を受け取る
    Public Sub txtlst(ByVal st As String)
        _txtlst.Add(st)
    End Sub
    'Excel.Worksheetの作成保存
    Public Sub shsave()
        Dim xlApp As New Excel.Application
        Dim xlBook As Excel.Workbook
        Dim xlSheet As Excel.Worksheet
        Try
            'Excelブックを起動    _dirpas & "\" & _flenme & ".xls"
            xlBook = xlApp.Workbooks.Open(_dirpas & "\" & _flenme & ".xls")   '基になる原紙のパス

            'Excelを表示
            xlApp.Visible = False

            xlSheet = xlBook.Worksheets(1)

            xlSheet.Cells(4, "k").Value = _txtlst(1)  '得意先名
            xlSheet.Cells(6, "k").Value = _txtlst(2)     '図　番
            xlSheet.Cells(8, "k").Value = _txtlst(3)     '品　名
            xlSheet.Cells(4, "ck").Value = _txtlst(4)    '得意先注番
            xlSheet.Cells(6, "ck").Value = _txtlst(5)    '発注番号
            xlSheet.Cells(8, "CC").Value = _txtlst(6)
            xlSheet.Cells(4, "db").Value = _txtlst(7)     '受注数
            xlSheet.Cells(6, "db").Value = _txtlst(8)    '材料数
            xlSheet.Cells(4, "dy").Value = _txtlst(9)    '加工予定数
            xlSheet.Cells(6, "dy").Value = _txtlst(10)      '完成在庫数
            xlSheet.Cells(8, "dy").Value = _txtlst(11)    '材料サイズ

            ' xlBook.Save() '上書き保存
            ' xlBook.SaveAs(_dirpas & "\" & _txtlst(0) & ".xls")  '名前をつけて保存
            '_dirpas & "\" & _txtlst(0) & ".xls"
            Dim pas As String = _dirpas & "\" & _txtlst(0) & ".xls"

            fledo.exlsours(_txtlst(0), pas)
            xlBook.SaveAs(pas)
            xlBook.Close()
            xlApp.Quit()

            '終了処理
            xlSheet = Nothing
            xlBook = Nothing
            xlApp = Nothing
            Dim ps() As Process = Process.GetProcessesByName("Excel")
            For Each p As Process In ps
                p.Kill()
            Next
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Exclamation)
        End Try
        _txtlst.Clear()
    End Sub
    '原紙のパスを Class Form3から受け取る
    Public Property dirpas() As String
        Get
            Return _dirpas
        End Get
        Set(value As String)
            _dirpas = value
        End Set
    End Property
    'ExcelのデータをClass Form2に渡す
    Public ReadOnly Property exlnet() As List(Of String)
        Get
            Return _cellst
        End Get
    End Property
   
End Class
